package eu.dnetlib.scholix.api.controller;

import eu.dnetlib.common.controller.AbstractDnetController;
import eu.dnetlib.scholix.api.model.v1.LinkPublisher;
import io.swagger.annotations.Api;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.List;


@RestController
@RequestMapping("/v1")
@Api(tags = {
        "Datasources"
})
public class DatasourceV1  extends AbstractDnetController {

    @Operation(
            summary = "Get all Datasources",
            description = "returns a list of all datasources")
    @GetMapping("/v1/listDatasources")
    public List<LinkPublisher> getDatasources() {
        return Arrays.asList(
                new LinkPublisher().name("pippo").totalRelationships(30),
                new LinkPublisher().name("pluto").totalRelationships(30),
                new LinkPublisher().name("peppa").totalRelationships(30)
        );
    }
}
