package eu.dnetlib.scholix.api.controller;
import eu.dnetlib.scholix.api.model.v2.LinkProviderType;
import io.swagger.annotations.Api;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Arrays;
import java.util.List;

@RestController
@RequestMapping("/v2")
@Api(tags = {
        "LinkProvider : Operation related to the Link Provider"
})
public class LinkProviderV2 {

    @Operation(
            summary = "Get all Link Providers",
            description = "Return a list of link provider and relative number of relations")
    @GetMapping("/LinkProvider")
    public List<LinkProviderType> getLinkProviders(
            @Parameter(in = ParameterIn.QUERY, description = "Filter the link provider name") @RequestParam(required = false) String name
    ) {
        return Arrays.asList(
                new LinkProviderType().name("pippo").totalRelationships(30),
                new LinkProviderType().name("pluto").totalRelationships(30),
                new LinkProviderType().name("peppa").totalRelationships(30)
        );
    }
}
