package eu.dnetlib.scholix.api.model.v1;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.v3.oas.annotations.media.Schema;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class ScholixCreator {

    @JsonProperty("name")
    private String name = null;

    @JsonProperty("identifier")
    private List<ScholixIdentifier> identifier = null;

    public ScholixCreator name(String name) {
        this.name = name;
        return this;
    }

    /**
     * Get name
     * @return name
     **/
    @Schema(required = true, description = "The name of the Object Creator")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public ScholixCreator identifier(List<ScholixIdentifier> identifier) {
        this.identifier = identifier;
        return this;
    }

    public ScholixCreator addIdentifierItem(ScholixIdentifier identifierItem) {
        if (this.identifier == null) {
            this.identifier = new ArrayList<ScholixIdentifier>();
        }
        this.identifier.add(identifierItem);
        return this;
    }

    /**
     * Get identifier
     * @return identifier
     **/
    @Schema(description = "A unique string that identifies the Object Creator")
    public List<ScholixIdentifier> getIdentifier() {
        return identifier;
    }

    public void setIdentifier(List<ScholixIdentifier> identifier) {
        this.identifier = identifier;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ScholixCreator ScholixCreator = (ScholixCreator) o;
        return Objects.equals(this.name, ScholixCreator.name) &&
                Objects.equals(this.identifier, ScholixCreator.identifier);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name, identifier);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ScholixCreator {\n");

        sb.append("    name: ").append(toIndentedString(name)).append("\n");
        sb.append("    identifier: ").append(toIndentedString(identifier)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}
