package eu.dnetlib.scholix.api.model.v2;

import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.ArrayList;
import java.util.List;

/**
 * The type Scholix item type.
 */
public class ScholixItemType {

    @JsonProperty("Identifier")
    private List<ScholixIdentifierType> identifier = new ArrayList();

    @JsonProperty("Title")
    private String title;

    @JsonProperty("Type")
    private String type;

    @JsonProperty("Creator")
    private List<ScholixCreatorType> creator = new ArrayList<>();

    @JsonProperty("PublicationDate")
    private String publicationDate;

    @JsonProperty("Publisher")
    private List<LinkProviderType> publisher = new ArrayList<>();


    /**
     * Gets identifier.
     *
     * @return the identifier
     */
    public List<ScholixIdentifierType> getIdentifier() {
        return identifier;
    }

    /**
     * Sets identifier.
     *
     * @param identifier the identifier
     * @return the identifier
     */
    public ScholixItemType setIdentifier(List<ScholixIdentifierType> identifier) {
        this.identifier = identifier;
        return this;
    }

    /**
     * Gets title.
     *
     * @return the title
     */
    public String getTitle() {
        return title;
    }

    /**
     * Sets title.
     *
     * @param title the title
     * @return the title
     */
    public ScholixItemType setTitle(String title) {
        this.title = title;
        return this;
    }

    /**
     * Gets type.
     *
     * @return the type
     */
    public String getType() {
        return type;
    }

    /**
     * Sets type.
     *
     * @param type the type
     * @return the type
     */
    public ScholixItemType setType(String type) {
        this.type = type;
        return this;
    }

    /**
     * Gets creator.
     *
     * @return the creator
     */
    public List<ScholixCreatorType> getCreator() {
        return creator;
    }

    /**
     * Sets creator.
     *
     * @param creator the creator
     * @return the creator
     */
    public ScholixItemType setCreator(List<ScholixCreatorType> creator) {
        this.creator = creator;
        return this;
    }

    /**
     * Gets publication date.
     *
     * @return the publication date
     */
    public String getPublicationDate() {
        return publicationDate;
    }

    /**
     * Sets publication date.
     *
     * @param publicationDate the publication date
     * @return the publication date
     */
    public ScholixItemType setPublicationDate(String publicationDate) {
        this.publicationDate = publicationDate;
        return this;
    }

    /**
     * Gets publisher.
     *
     * @return the publisher
     */
    public List<LinkProviderType> getPublisher() {
        return publisher;
    }

    /**
     * Sets publisher.
     *
     * @param publisher the publisher
     * @return the publisher
     */
    public ScholixItemType setPublisher(List<LinkProviderType> publisher) {
        this.publisher = publisher;
        return this;
    }
}
