package eu.dnetlib.scholix.api.model.v2;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.v3.oas.annotations.media.Schema;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * The type Scholix link provider type.
 */
public class ScholixLinkProviderType {
    @NotBlank
    @JsonProperty("name")
    private String name = null;


    @NotBlank
    @JsonProperty("identifier")
    private List<ScholixIdentifierType> identifier = new ArrayList<>();

    /**
     * Gets A List of unique string that identifies the object
     *
     * @return the identifier
     */
    @Schema(description = "A List of unique string that identifies the object")
    public List<ScholixIdentifierType> getIdentifier() {
        return identifier;
    }

    /**
     * Sets A List of unique string that identifies the object
     *
     * @param identifier the identifier
     * @return the identifier
     */
    public ScholixLinkProviderType setIdentifier(List<ScholixIdentifierType> identifier) {
        this.identifier = identifier;
        return this;
    }


    /**
     * Gets The name of the Provider
     *
     * @return the name
     */
    @Schema(description = "The name of the Provider")
    public String getName() {
        return name;
    }

    /**
     * Sets The name of the Provider
     *
     * @param name the name
     * @return the name
     */
    public ScholixLinkProviderType setName(String name) {
        this.name = name;
        return this;
    }
}